"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.assert = void 0;
const nodeAssert = __importStar(require("assert"));
const parseAsssetion_js_1 = require("../helpers/parseAsssetion.js");
const format_js_1 = require("../helpers/format.js");
const ok = (value, message) => (0, parseAsssetion_js_1.parseAssertion)(() => nodeAssert.ok(value), { message });
const equal = (actual, expected, message) => (0, parseAsssetion_js_1.parseAssertion)(() => nodeAssert.equal(actual, expected), { message });
const deepEqual = (actual, expected, message) => (0, parseAsssetion_js_1.parseAssertion)(() => nodeAssert.deepEqual(actual, expected), { message });
const strictEqual = (actual, expected, message) => (0, parseAsssetion_js_1.parseAssertion)(() => nodeAssert.strictEqual(actual, expected), { message });
const deepStrictEqual = (actual, expected, message) => (0, parseAsssetion_js_1.parseAssertion)(() => nodeAssert.deepStrictEqual(actual, expected), {
    message,
});
const doesNotMatch = (value, regExp, message) => (0, parseAsssetion_js_1.parseAssertion)(() => nodeAssert.doesNotMatch(value, regExp), {
    message,
    actual: 'Value',
    expected: 'RegExp',
    defaultMessage: format_js_1.format.bold('Value should not match regExp'),
});
function doesNotReject(block, errorOrMessage, message) {
    return __awaiter(this, void 0, void 0, function* () {
        if (typeof errorOrMessage === 'function' ||
            errorOrMessage instanceof RegExp ||
            typeof errorOrMessage === 'object') {
            try {
                return yield nodeAssert.doesNotReject(block, errorOrMessage);
            }
            catch (error) {
                (0, parseAsssetion_js_1.parseAssertion)(() => {
                    throw error;
                }, {
                    message,
                    defaultMessage: format_js_1.format.bold('Got unwanted rejection'),
                    hideDiff: true,
                    throw: true,
                });
            }
        }
        else {
            try {
                return yield nodeAssert.doesNotReject(block);
            }
            catch (error_1) {
                (0, parseAsssetion_js_1.parseAssertion)(() => {
                    throw error_1;
                }, {
                    message: typeof errorOrMessage === 'string' ? errorOrMessage : undefined,
                    defaultMessage: format_js_1.format.bold('Got unwanted rejection'),
                    hideDiff: true,
                    throw: true,
                });
            }
        }
    });
}
function doesNotThrow(block, errorOrMessage, message) {
    if (typeof errorOrMessage === 'function' ||
        errorOrMessage instanceof RegExp ||
        typeof errorOrMessage === 'object') {
        try {
            nodeAssert.doesNotThrow(block, errorOrMessage, message);
        }
        catch (error) {
            (0, parseAsssetion_js_1.parseAssertion)(() => {
                throw error;
            }, {
                message: message,
                defaultMessage: format_js_1.format.bold('Expected function not to throw'),
                hideDiff: true,
                throw: true,
            });
        }
    }
    else {
        const msg = typeof errorOrMessage === 'string' ? errorOrMessage : undefined;
        try {
            nodeAssert.doesNotThrow(block, msg);
        }
        catch (error) {
            (0, parseAsssetion_js_1.parseAssertion)(() => {
                throw error;
            }, {
                message: msg,
                defaultMessage: format_js_1.format.bold('Expected function not to throw'),
                hideDiff: true,
                throw: true,
            });
        }
    }
}
function throws(block, errorOrMessage, message) {
    if (typeof errorOrMessage === 'function' ||
        errorOrMessage instanceof RegExp ||
        typeof errorOrMessage === 'object') {
        try {
            nodeAssert.throws(block, errorOrMessage, message);
        }
        catch (error) {
            (0, parseAsssetion_js_1.parseAssertion)(() => {
                throw error;
            }, {
                message: message,
                defaultMessage: format_js_1.format.bold('Expected function to throw'),
                hideDiff: true,
            });
        }
    }
    else {
        const msg = typeof errorOrMessage === 'string' ? errorOrMessage : undefined;
        try {
            nodeAssert.throws(block, message);
        }
        catch (error) {
            (0, parseAsssetion_js_1.parseAssertion)(() => {
                throw error;
            }, {
                message: msg,
                defaultMessage: format_js_1.format.bold('Expected function to throw'),
                hideDiff: true,
            });
        }
    }
}
const notEqual = (actual, expected, message) => (0, parseAsssetion_js_1.parseAssertion)(() => nodeAssert.notEqual(actual, expected), {
    message,
});
const notDeepEqual = (actual, expected, message) => (0, parseAsssetion_js_1.parseAssertion)(() => nodeAssert.notDeepEqual(actual, expected), { message });
const notStrictEqual = (actual, expected, message) => (0, parseAsssetion_js_1.parseAssertion)(() => nodeAssert.notStrictEqual(actual, expected), {
    message,
});
const notDeepStrictEqual = (actual, expected, message) => (0, parseAsssetion_js_1.parseAssertion)(() => nodeAssert.notDeepStrictEqual(actual, expected), {
    message,
});
const match = (value, regExp, message) => (0, parseAsssetion_js_1.parseAssertion)(() => nodeAssert.match(value, regExp), {
    message,
    actual: 'Value',
    expected: 'RegExp',
    defaultMessage: format_js_1.format.bold('Value should match regExp'),
});
const ifError = (value) => {
    try {
        nodeAssert.ifError(value);
    }
    catch (error) {
        (0, parseAsssetion_js_1.parseAssertion)(() => {
            throw error;
        }, {
            defaultMessage: format_js_1.format.bold('Expected no error, but received an error'),
            hideDiff: true,
            throw: true,
        });
    }
};
const fail = (message) => {
    try {
        nodeAssert.fail(message);
    }
    catch (error) {
        (0, parseAsssetion_js_1.parseAssertion)(() => {
            throw error;
        }, {
            message,
            defaultMessage: format_js_1.format.bold('Test failed intentionally'),
            hideDiff: true,
        });
    }
};
function rejects(block, errorOrMessage, message) {
    return __awaiter(this, void 0, void 0, function* () {
        if (typeof errorOrMessage === 'function' ||
            errorOrMessage instanceof RegExp ||
            typeof errorOrMessage === 'object') {
            try {
                return yield nodeAssert.rejects(block, errorOrMessage);
            }
            catch (error) {
                (0, parseAsssetion_js_1.parseAssertion)(() => {
                    throw error;
                }, {
                    message,
                    defaultMessage: format_js_1.format.bold('Expected promise to be rejected with specified error'),
                    hideDiff: true,
                });
            }
        }
        else {
            const msg = typeof errorOrMessage === 'string' ? errorOrMessage : undefined;
            try {
                return yield nodeAssert.rejects(block);
            }
            catch (error_1) {
                (0, parseAsssetion_js_1.parseAssertion)(() => {
                    throw error_1;
                }, {
                    message: msg,
                    defaultMessage: format_js_1.format.bold('Expected promise to be rejected'),
                    hideDiff: true,
                });
            }
        }
    });
}
exports.assert = Object.assign((value, message) => ok(value, message), {
    ok,
    equal,
    deepEqual,
    strictEqual,
    deepStrictEqual,
    doesNotMatch,
    doesNotReject,
    throws,
    doesNotThrow,
    notEqual,
    notDeepEqual,
    notStrictEqual,
    notDeepStrictEqual,
    match,
    ifError,
    fail,
    rejects,
});
